Package: ctc
Version: 1.86.0
Date: 2005-11-16
Depends: amap
Title: Cluster and Tree Conversion.
Author: Antoine Lucas <antoinelucas@gmail.com>, Laurent Gautier <laurent@cbs.dtu.dk>
biocViews: Microarray, Clustering, Classification, DataImport,
        Visualization
Maintainer: Antoine Lucas <antoinelucas@gmail.com>
Description: Tools for export and import classification trees and clusters to other programs
License: GPL-2
URL: http://antoinelucas.free.fr/ctc
git_url: https://git.bioconductor.org/packages/ctc
git_branch: RELEASE_3_23
git_last_commit: 23f03f4
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:50:03 UTC; biocbuild
Built: R 4.6.0; ; 2026-04-29 04:38:57 UTC; unix

read.eisen <- function(file,sep="\t",dec=".",format.check=TRUE) {

        f<-read.table(file=file,header=TRUE,sep=sep,dec=dec)

        rownames(f)<-f[,1]
        if (format.check & colnames(f)[1] %in% c("UNIQID","YORF","MCLID","CLID","ACC")) {
          stop(paste("This is not a proper Eisen-formatted file ('",file,"').",sep=""))
        }

        if ("NAME"==colnames(f)[2]) {
                colstart<-3
        } else {
                colstart<-2
        }

        if (""==rownames(f)[1]) {
                rowstart<-2
        } else {
                rowstart<-1
        }

        r<-f[rowstart:nrow(f),colstart:ncol(f)]

        if (2==rowstart) {
                attr(r,"second.row")<-f[1,colstart:ncol(f)]
        } else {
                attr(r,"second.row")<-NULL
        }

        if (3==colstart) {
                attr(r,"NAME")<-f[rowstart:nrow(f),2]
        } else {
                attr(r,"NAME")<-NULL
        }

        return(r)
}

r2cdt <- function(hr,hc,data,labels=FALSE,description=FALSE,file="cluster.cdt",dec="."){
#-------------------------------------------------------
#
#  Created       : 20/11/02
#  Last Modified : Time-stamp: <2003-07-22 16:52:28 lucas>
#
#  Description   : Write data object to cdt 
#                  file (Xcluster or Cluster output).
#                  Should be use with r2gtr
#                  Visualisation of cluster can be
#                  done with tools like treeview
#
#                  Author        : Antoine Lucas
#                  lucas@toulouse.inra.fr
#
#  Licence       : GPL (r2xcluster, not Xcluster)
#
#-------------------------------------------------------
#
#

  n <- dim(data)[1]

  # Add GWEIGHT column
  data <- as.data.frame(cbind(1,data))
  

  # If the name column does not exist -> creation
  # of this column else: put column name on
  # first place. (column NAME in the file)
  if(!description){
    if(!labels){
      data <- cbind(row.names(data),data)
    }
    else{
      data <- cbind(as.factor(data[,2]),data)
    }
  }
  else{
    data <- cbind(as.factor(data[,3]),data[,-3])        
      }
  # column YORF in the file
  if(!labels){
    data <- cbind(row.names(data),data)
  }
  else{
    data <- cbind(as.factor(data[,3]),data[,-3])
  }

  # add GID column
  GID <- paste ('GENE',0:(n-1),'X',sep='')
  data <- cbind(as.factor(GID),data)

  # Put data in right order
  data <- data [hr$order,]

  m <- dim(data)[2]
  data[,5:m] <- data[,5:m][hc$order]
  colnames(data)[5:m] <-  colnames(data)[5:m][hc$order]
  
  # Round data
  data[,5:m] <- signif(data[,5:m], digits = 4)


  levels(data[,1]) <- c(levels(data[,1]),"1","GID","AID","EWEIGHT")
  levels(data[,2]) <- c(levels(data[,2]),"1","UNIQID")
  levels(data[,3]) <- c(levels(data[,3]),"1","NAME")
  data <- rbind(1,data)
  nom <- c("GID","UNIQID","NAME","GWEIGHT",names(data)[-c(1,2,3,4)])
  names(data) <- nom
  data[1,1] <- "EWEIGHT"
  data <- rbind(c("AID",NA,NA,NA,paste('ARRY',hc$order-1,'X',sep='')),data)
  
  # NA will be replaced by "" in the file
  # data[2:length(data[,1]),2] <- NA
  data[2,2:4] <- NA

  # Write file
  if(dec==',')
    {
      data<-apply(data,2,function(u){chartr(".",",",u)})
      data[data=="NA"]<-NA
    }
  write.table(data,file = file,sep = '\t',row.names = FALSE,col.names = TRUE,na="",quote=FALSE)

}

r2cluster <- function(data,labels=FALSE,colname="ACC",description=FALSE,file="cluster.txt",dec='.'){
#-------------------------------------------------------
#
#  Created       : 05/07/02
#  Last Modified : Time-stamp: <2003-07-22 16:53:00 lucas>
#
#  Description   : Write to Cluster file format (Cluster make
#                  Hierarchical cluster analysis)
#  Author        : Antoine Lucas
#                  lucas@toulouse.inra.fr
#  See Also      : r2xcluster
#
#  Xcluster      : Cluster is a program that performs
#                  hierarchical clustering, K-means and
#                  SOM. 
#                  Cluster is copyrighted. 
#                  To get or have information on Cluster:
#          
#                  http://rana.lbl.gov/EisenSoftware.htm
#
#  Licence       : GPL 
#
#
#-------------------------------------------------------
#
#
# Example:
# source('r2cluster.R')
# r2cluster(data)
#
#-------------------------------------------------------

n <- length(data[,1])
data <- as.data.frame(cbind(1,1:n,data))

# If the name column does not exist -> creation
# of this column, else: put column name on
# first place.
if(!description){
        if(!labels){
                data <- cbind(row.names(data),data)
        }
        else{
                data <- cbind(as.factor(data[,3]),data)
        }
}
else{
        data <- cbind(as.factor(data[,4]),data[,-4])
}
if(!labels){
        data <- cbind(row.names(data),data)
}
else{
        data <- cbind(as.factor(data[,4]),data[,-4])
}
levels(data[,1]) <- c(levels(data[,1]),"1",colname,"EWEIGHT")
levels(data[,2]) <- c(levels(data[,2]),"1","NAME","EWEIGHT")
data <- rbind(1,data)
nom <- c(colname,"NAME","GWEIGHT","GORDER",names(data)[-c(1,2,3,4)])
names(data) <- nom
data[1,1] <- "EWEIGHT"
data[1,2:4] <- NA

# NA will be replaced by "" in the file
#data[2:length(data[,1]),2] <- NA
#data[2,3] <- NA

# Write file
if(dec==',')
  {
    data<-apply(data,2,function(u){chartr(".",",",u)})
    data[data=="NA"]<-NA
  }

write.table(data,file,sep='\t',row.names = FALSE,col.names = TRUE,na="",quote=FALSE)
}

hclust2treeview <- function(x,file="cluster.cdt",method = "euclidean",
                              link = "complete",keep.hclust=FALSE)
  {
    if("amap" %in% .packages(all=TRUE))
      {
        hr <- hcluster (x,method =method, link=link)
        hc <- hcluster (t(x),method =method, link=link)
      }
    else
      {
        hr <- hclust(dist(x,method =method), method=link)
        hc <- hclust(dist(t(x),method =method), method=link)
      }
    basefile = strsplit(file,"\\.")[[1]]
    if(length(basefile>1))  
      basefile = paste(basefile[-length(basefile)],collapse=".")

    
    
    r2atr(hc,file=paste(basefile,".atr",sep=""))
    r2gtr(hr,file=paste(basefile,".gtr",sep=""))
    r2cdt(hr,hc,x ,file=paste(basefile,".cdt",sep=""))

    if(keep.hclust)
      return(list(hr,hc))
    else
      return(1)
  }

r2xcluster <- function(data,labels=FALSE,description=FALSE,file="xcluster.txt"){
#-------------------------------------------------------
#
#  Created       : 10/12/01
#  Last Modified : Time-stamp: <2002-11-12 13:17:15 lucas>
#
#  Description   : Write to Xcluster file format (Xcluster make
#                  Hierarchical cluster analysis)
#  Author        : Antoine Lucas
#                  lucas@toulouse.inra.fr
#  See Also      : xcluster2r
#
#  Xcluster      : Xcluster is a C program that performs
#                  hierarchical clustering, K-means and
#                  SOM. 
#                  Xcluster is copyrighted. 
#                  To get or have information on Xcluster:
#          
#                  http://genome-www.stanford.edu/~sherlock/cluster.html     
#
#  Licence       : GPL (r2xcluster, not Xcluster)
#
#-------------------------------------------------------
#
#
# Example:
# source('r2xcluster.R')
# r2xcluster(data)
# system('Xcluster -f xcluster.txt')
# h <- xcluster2r('xcluster.gtr')
# library(mva)
# plot(h,hang=-1)
#
#-------------------------------------------------------


data <- as.data.frame(cbind(1,data))

# If the name column does not exist -> creation
# of this column else: put column name on
# first place.
if(!description){
        if(!labels){
                data <- cbind(row.names(data),data)
        }
        else{
                data <- cbind(as.factor(data[,2]),data)
        }
}
else{
	data <- cbind(as.factor(data[,3]),data[,-3])        
}
if(!labels){
        data <- cbind(row.names(data),data)
}
else{
        data <- cbind(as.factor(data[,3]),data[,-3])
}

levels(data[,1]) <- c(levels(data[,1]),"1","NAME","EWEIGHT")
levels(data[,2]) <- c(levels(data[,2]),"1","DESCRIPTION")
data <- rbind(1,data)
nom <- c("NAME","DESCRIPTION","GWEIGHT",names(data)[-c(1,2,3)])
data <- rbind(nom,data)
data[2,1] <- "EWEIGHT"

# NA will be replaced by "" in the file
#data[2:length(data[,1]),2] <- NA
data[2,2:3] <- NA

# Write file
write.table(data,file,sep='\t',row.names = FALSE,col.names = FALSE,na="",quote=FALSE)
}

cat ("\n\n            C T C  \n             D E M O \n\n")


cat("\n------ Standard clustering with R (not ctc):  -------\n")

data(USArrests)
h = hclust(dist(USArrests))
plot(h)
 
readline("Next")

cat("\n------ Get the ``heatmap'':  -------\n")
heatmap(as.matrix(USArrests))

readline("Next")

cat("\n------ BUILDING HIERARCHICAL CLUSTERING WITH ANOTHER SOFTWARE  -------\n")
cat("\n------ Write data table to Xcluster file format   -------\n")
r2xcluster(USArrests,file='USArrests_xcluster.txt')
readline("Next")

cat("\n------ Write data table to cluster file format   -------\n")
r2cluster(USArrests,file='USArrests_cluster.txt')
readline("Next")

cat("\n------ Hierarchical clustering (need Xcluster tool  by Gavin Sherlock)  -------\ntry:\n\nh.xcl=xcluster(USArrests)\nplot(h.xcl)
") 



readline("Next")



hr = hclust(dist(USArrests))
hc = hclust(dist(t(USArrests)))
cat("\n------  USING OTHER VISUALIZATION SOFTWARES  -------\n")

cat("\n------  Export hclust objects to Newick format files  -------\n")
write(hc2Newick(hr),file='hclust.newick')
readline("Next")

cat("\n------  Export hclust objects to Freeview or Treeview
visualization softwares  -------\n")
r2atr(hc,file="cluster.atr")
r2gtr(hr,file="cluster.gtr")
r2cdt(hr,hc,USArrests ,file="cluster.cdt")
readline("Next")


cat("\n------  Clustering and Export hclust objects to Freeview or Treeview
visualization softwares  -------\n")

hclust2treeview(USArrests,file="cluster.cdt")

r2gtr <- function(hr,file="cluster.gtr",distance=hr$dist.method,dec=".",
                  digits=5)
{
#-------------------------------------------------------
#
#  Created       : 20/11/02	
#  Last Modified : Time-stamp: <2005-04-05 16:06:45 lucas>
#
#  Description   : Write hclust object to gtr atr
#                  files (Xcluster or Cluster output).
#                  Visualisation of cluster can be
#                  done with tools like treeview
#  Author        : Antoine Lucas
#                  lucas@toulouse.inra.fr
#  See Also      : plot.hclust  (library mva)
#
#  Licence       : GPL 
#-------------------------------------------------------



  height <- hr$height

  if(substr(distance,1,1)=="p")
    {
      height  <- 1 - height
    }
  else 
    {
      height <- height +1
      height  <- height[1] / height
#      height  <- (( 2 / height ) -1 ) / (( 2 / height[1] ) -1)
    }
  height  <- signif(height, digits = digits)
  
  
  n <- length(height)
  node <- 1:n
  node <- paste ('NODE',node,'X',sep='')

  merge1  <- hr$merge[,1]
  merge11 <- paste ('NODE',merge1,'X',sep='')
  merge12 <- paste ('GENE',-1-merge1,'X',sep='')
  merge1[hr$merge[,1]>0] <- merge11[hr$merge[,1]>0]
  merge1[hr$merge[,1]<0] <- merge12[hr$merge[,1]<0]
  
  merge2  <- hr$merge[,2]
  merge11 <- paste ('NODE',merge2,'X',sep='')
  merge12 <- paste ('GENE',-1-merge2,'X',sep='')
  merge2[hr$merge[,2]>0] <- merge11[hr$merge[,2]>0]
  merge2[hr$merge[,2]<0] <- merge12[hr$merge[,2]<0]


  data  <- data.frame(cbind(node,merge1,merge2))
  data  <- cbind(data,height)
 
  write.table(data,file=file,row.name=FALSE,col.names=FALSE,quote=FALSE,sep='\t',dec=dec)

}


#-----------------------------------
# Cosmetic modifications for r2atr
#-----------------------------------
r2atr <- function(hc,file="cluster.atr",distance=hc$dist.method,dec=".",
                  digits=5)
{



  height <- hc$height

  if(substr(distance,1,1)=="p")
    {
      height  <- 1 - height
    }
  else 
    {
      height <- height +1
      height  <- height[1] / height
    }
  height  <- signif(height, digits = digits)
  
  
  n <- length(height)
  node <- 1:n
  node <- paste ('NODE',node,'X',sep='')

  merge1  <- hc$merge[,1]
  merge11 <- paste ('NODE',merge1,'X',sep='')
  merge12 <- paste ('ARRY',-1-merge1,'X',sep='')
  merge1[hc$merge[,1]>0] <- merge11[hc$merge[,1]>0]
  merge1[hc$merge[,1]<0] <- merge12[hc$merge[,1]<0]
  
  merge2  <- hc$merge[,2]
  merge11 <- paste ('NODE',merge2,'X',sep='')
  merge12 <- paste ('ARRY',-1-merge2,'X',sep='')
  merge2[hc$merge[,2]>0] <- merge11[hc$merge[,2]>0]
  merge2[hc$merge[,2]<0] <- merge12[hc$merge[,2]<0]


  data  <- data.frame(cbind(node,merge1,merge2))
  data  <- cbind(data,height)
 
  if(dec==',')
    {
      data<-apply(data,2,function(u){chartr(".",",",u)})
      data[data=="NA"]<-NA
    }

  write.table(data,file=file,row.name=FALSE,col.names=FALSE,quote=FALSE,sep='\t')

}

xcluster2r <- function(file,distance="euclidean",labels=FALSE,fast=FALSE,clean=FALSE,dec="."){
#-------------------------------------------------------
#
#  Created       : 26/11/01
#  Last Modified : Time-stamp: <2002-11-22 11:48:29 lucas>
#
#  Description   : Read Xcluster output (Xcluster make
#                  Hierarchical cluster analysis) to
#                  analyse and plot the result. 
#  Author        : Antoine Lucas
#                  lucas@toulouse.inra.fr
#  See Also      : plot.hclust  (library mva)
#
#  Xcluster      : Xcluster is a C program that performs
#                  hierarchical clustering, K-means and
#                  SOM. 
#                  Xcluster is copyrighted. 
#                  To get or have information on Xcluster:
#          
#                  http://genome-www.stanford.edu/~sherlock/cluster.html     
#
#  Licence       : GPL (xcluster2r, not Xcluster)
#
#
#-------------------------------------------------------
#
#
# Example:
# source('xcluster2r.R')
# h <- xcluster2r('data.gtr')
# library(mva)
# plot(h,hang=-1)
#
#
#------------------------------
#  Determin if it is a .gtr or
#   .atr file
#------------------------------
ext <- substr(file,nchar(file)-2,nchar(file)-2)
if( (ext=='a') || (ext=='A') )
{
        premierelettre  <- 'A'
        atr             <- TRUE
}
else
{
        premierelettre  <- 'G'
        atr             <- FALSE
}

#------------------------------
#         reading file
#------------------------------



if(atr){
        premierelettre  <- 'A'
       }
else   {
        premierelettre  <- 'G'
       }

data    <- read.table(file,sep='\t',dec=dec)
data1   <- as.character(data[,2])
i1      <- (substr(data1,1,1)==premierelettre)*(-1)
#si i1 -1 => Gene, 
#Si i1  0 => Cluster
data1   <-  as.integer(substr(data1,5,nchar(data1)-1))
data1   <-  data1*i1+i1+data1*(1+i1)
data2   <- as.character(data[,3])
i2      <- (substr(data2,1,1)==premierelettre)*(-1)
data2   <-  as.integer(substr(data2,5,nchar(data2)-1))
data2   <-  data2*i2+i2+data2*(1+i2)
if(substr(distance,1,1)=="e")
   {
   Hheight <- 2 / (data[,4] +1 )   #Distance = Euclidean 
   }
   else{
   Hheight <- 1-data[,4]           #Distance = pearson (centered or not)
   }
rm(data)


#----------------------------------------------------
#         Giving ordered distances
#----------------------------------------------------
if(clean){
    Hheight <- cummax(Hheight)
    }



#----------------------------------------------------
#         Reorganizing data (Not essential, 
#         but gives the same look as R)
#         Fast=T skip this part
#----------------------------------------------------
if(!fast){
for(i in 1:length(data1)){
        if(abs(data1[i])>abs(data2[i])){
                tmp      <- data2[i]
                data2[i] <- data1[i]
                data1[i] <- tmp}
        if(data1[i]>0 && data2[i]<0)
        {
                tmp2     <- data2[i]
                data2[i] <- data1[i]
                data1[i] <- tmp2
        }
}
}
#----------------------------------------------------
#          Order the clusters 
#----------------------------------------------------

liste <- list("1"=c(data1[1],data2[1]))
for(i in 2:length(data1)){
        if(data1[i]<0 && data2[i]<0){
                liste[[as.character(i)]] <- c(data1[i],data2[i])
        }
        if(data1[i]>0 && data2[i]<0)
        {
                tmp <- as.character(data1[i])
                liste[[as.character(i)]] <- c(data2[i],liste[[tmp]])
                liste[[tmp]] <- c()
         }
        if(data1[i]<0 && data2[i]>0)
        {
                tmp <- as.character(data2[i])
                liste[[as.character(i)]] <- c(data1[i],liste[[tmp]])
                liste[[tmp]] <- c()
        }
        if(data1[i]>0 && data2[i]>0)
        {
                tmp1 <- as.character(data1[i])
                tmp2 <- as.character(data2[i])
                if(data1[i]<=data2[i])
                {
                        liste[[as.character(i)]] <- c(liste[[tmp1]],liste[[tmp2]])
                }
                else
                {
                        liste[[as.character(i)]] <- c(liste[[tmp2]],liste[[tmp1]])
                }                
                liste[[tmp1]] <- c()
                liste[[tmp2]] <- c()
        }
}


#--------------------------------
#       Giving the outputs
#-------------------------------- 

Hmerge  <- cbind(as.integer(data1),as.integer(data2))
Horder  <- -liste[[as.character(length(data2))]]
Hlabels <- as.character(1:(length(data2)+1))
Hmethod <- "average"
#Hdist.method <- "Pearson"
#Hcall  <- "Xcluster"

#--------------------------------
#  Getting labels on .cdt file
#--------------------------------
if(labels){
	if(atr)
	{
                filetxt <- paste(substr(file,0,nchar(file)-4),'.txt',sep='')
                data    <- read.table(filetxt,nrows=1,sep='\t',dec=dec)
                Hlabels <- as.character(t(data[4:length(data)]))
	}
	else
	{
                filecdt <- paste(substr(file,0,nchar(file)-4),'.cdt',sep='')
                data    <- read.table(filecdt,skip=1,sep='\t',dec=dec)
                data1   <- as.character(data[,1])
                data1   <- as.integer(substr(data1,5,nchar(data1)-1))
                data2   <- as.character(data[,2])
                Hlabels[data1+1] <- data2
        }
}

tree    <- list(merge=Hmerge,height=Hheight,order=Horder,labels=Hlabels,method=Hmethod)
class(tree) <- "hclust"
tree
}

xcluster <- function(data,distance="euclidean",clean=FALSE,tmp.in="tmp.txt",tmp.out="tmp.gtr"){
#-------------------------------------------------------
#
#  Created       : 10/12/01
#  Last Modified : Time-stamp: <2002-11-12 09:48:10 lucas>
#
#  Description   : Execute Xcluster (Xcluster make
#                  Hierarchical cluster analysis)
#  Author        : Antoine Lucas
#                  lucas@toulouse.inra.fr
#  See Also      : xcluster2r
#
#  Xcluster      : Xcluster is a C program that performs
#                  hierarchical clustering, K-means and
#                  SOM. 
#                  Xcluster is copyrighted. 
#                  To get or have information on Xcluster:
#          
#                  http://genome-www.stanford.edu/~sherlock/cluster.html     
#
#  Licence       : GPL (r2xcluster, not Xcluster)
#
#
#-------------------------------------------------------
#  Xcluster flags
#-------------------------------------------------------
#
# -g 0|1|2 ; 0 indicates no gene clustering, 1 indicates non-centered metric, 2 indicates centered metric when clustering genes.  2 is default.
# -e 0|1|2 ; 0 indicates no experiment clustering, see above for 1 and 2.  0 is the default.
# -p 0|1 ; whether to use pearson correlation (1), or Euclidean distance (0).  1 is the default.
# -s 0|1 ; whether to make a SOM (1). 0 is the default. 
# -x specify x dimension of SOM
# -y specify y dimension of SOM
# -r 0|1 ; whether to seed the random number generator with the time when making a SOM.  1 is the default.
# -k num ; how many k-means clusters to make.  num is an integer, greater than 1, and preferably less than a gazillion. 
# -l 0|1 ; whether to log transform the data.
# -u string ; a unique identifier by which to name the output files, instead of basing their names on the input file.  eg -u 888 will generate 888.cdt as an output file.
#-------------------------------------------------------
#
#
# Example:
# source('r2xcluster.R')
# system('Xcluster -f xcluster.txt')
# h <- xcluster2r('xcluster.gtr')
# library(mva)
# plot(h,hang=-1)
#
#-------------------------------------------------------

r2xcluster(data,file=tmp.in)

#-------------------------------------
#      CASE DISTANCE=EUCLIDEAN
#-------------------------------------
if(substr(distance,1,1)=="e")
   {
    script <- paste ("Xcluster -f",tmp.in," -e 0 -p 0 -s 0 -l 0")
    system(script)
    tree <- xcluster2r(file=tmp.out,distance="euclidean",labels=TRUE,fast= TRUE,clean=clean)
    }
#-------------------------------------
#      CASE DISTANCE=PEARSON
#-------------------------------------
if(substr(distance,1,1)=="p")
   {
    script <- paste ("Xcluster -f",tmp.in,"-g 2 -e 0 -p 1 -s 0 -l 0")
    system(script)
    tree <- xcluster2r(file=tmp.out,distance="pearson",labels=TRUE,fast= TRUE,clean=clean)
    }
#-------------------------------------
#   CASE DISTANCE=NONCENTEREDPEARSON
#-------------------------------------
if(substr(distance,1,1)=="n")
   {
    script <- paste ("Xcluster -f",tmp.in,"-g 1 -e 0 -p 1 -s 0 -l 0")
    system(script)
    tree <- xcluster2r(file=tmp.out,distance="pearson",labels=TRUE,fast= TRUE,clean=clean)
    }


script <-  paste ("rm ",substr(tmp.in,0,nchar(tmp.in)-3),"*",sep='')
system(script)
tree
}

hc2Newick <- function(hc, flat=TRUE) {

  dist <- 0
  if (is.null(hc$labels))
    labels <- seq(along=hc$order)
  else
    labels <- hc$labels

  putparenthesis <- function(i) {
    ## recursive function
    ## i: index of row in hc$merge
    j <- hc$merge[i, 1]
    k <- hc$merge[i, 2]
    
    if (j < 0) {
      left <- labels[-j]
      if (k > 0)
        dist <- hc$height[i] - hc$height[k]
      else
        dist <- hc$height[i]
    } else {
      left <- putparenthesis(j)
    }

    if (k < 0) {
      right <- labels[-k]
      if (j > 0)
        dist <- hc$height[i] - hc$height[j]
      else
        dist <- hc$height[i]
    } else {
      right <- putparenthesis(k)
    } 
    if (flat)
      return(paste("(", left, ":", dist/2, ",", right, ":", dist/2, ")", sep=""))
    else
      return(list(left=left, right=right, dist=dist))
  }
  
  n <- putparenthesis(nrow(hc$merge))
  if (flat)
    n <- paste(n, ";", sep="")
  
  return(n)
}

% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
% building this document: (in R) Sweave ("ctc.Rnw")
\documentclass[a4paper]{article}

\title{Ctc Package}
\author{Antoine Lucas}

\SweaveOpts{echo=FALSE}
%\usepackage{a4wide}
%\VignetteIndexEntry{Introduction to ctc}
%\VignettePackage{ctc}
\usepackage{url}

\begin{document}

\maketitle

\tableofcontents

\section{Overview}

{\tt Ctc} package provides several functions for 
conversion. Specially to export and import data from
Xcluster\footnote{\url{http://genome-www.stanford.edu/~sherlock/cluster.html}} 
 or Cluster\footnote{http://rana.lbl.gov/EisenSoftware.htm} 
 software (very used for Gene's expression
analysis), and to export clusters to TreeView or Freeview visualization
software.

\section{Aim} 

\begin{itemize}
\item To explore clusters made by Xcluster and Cluster . 

\item To cluster data with Xcluster (it requires very low memory usage) 
and analyze the results with R. Warning: results are not exactly the same
as hclust results with R. 
\end{itemize}              
       
\section{Usage}

Standard way of building a hierarchical clustering with R
is with this command:
%<<echo=TRUE,fig=TRUE>>=
<<echo=TRUE>>=
data(USArrests)
h = hclust(dist(USArrests))
plot(h)
@ 
Or for the ``heatmap'':
<<echo=TRUE,fig=TRUE>>=
heatmap(as.matrix(USArrests))
@ 


\subsection{Building hierarchical clustering with another software}

We made these tools
\begin{description}
\item[r2xcluster] Write data table to Xcluster file format 
<<echo=TRUE>>=
library(ctc)
r2xcluster(USArrests,file='USArrests_xcluster.txt')
@ 
 \item[r2cluster] Write data table to Cluster file format 
<<echo=TRUE>>=
r2cluster(USArrests,file='USArrests_xcluster.txt')
@ 
\item[xcluster] Hierarchical clustering (need Xcluster tool  by Gavin Sherlock) 
\begin{verbatim}
> h.xcl=xcluster(USArrests)
> plot(h.xcl)
\end{verbatim}
 
It is roughtly the same as
\begin{verbatim}
> r2xcluster(USArrests,file='USArrests_xcluster.txt')
> system('Xcluster -f USArrests_xcluster.txt -e 0 -p 0 -s 0 -l 0')
> h.xcl=xcluster2r('USArrests_xcluster.gtr',labels=TRUE)
\end{verbatim}


\item[xcluster2r] Importing Xcluster/Cluster output 

\end{description}                 

\subsection{Using other visualization softwares}

We now consider that we have an object of the type produced by 'hclust'
(or a hierarchical cluster imported with previous functions) like:

<<echo=TRUE>>=
hr = hclust(dist(USArrests))
hc = hclust(dist(t(USArrests)))
@ 



\begin{description}
\item[hc2Newick] Export hclust objects to Newick format files
<<echo=TRUE>>=
write(hc2Newick(hr),file='hclust.newick')
@ 
\item[r2gtr,r2atr,r2cdt] Export hclust objects to Freeview or Treeview
visualization softwares
<<echo=TRUE>>=
r2atr(hc,file="cluster.atr")
r2gtr(hr,file="cluster.gtr")
r2cdt(hr,hc,USArrests ,file="cluster.cdt")
@ 
\item[hclust2treeview] Clustering and Export hclust objects to Freeview or Treeview
visualization softwares 
<<echo=TRUE>>=
hclust2treeview(USArrests,file="cluster.cdt")
@ 
\end{description}

    
\section{See Also}

Theses examples can be tested with command
{\tt demo(ctc)}.\\


\noindent
All functions has got man pages, try 
{\tt help.start()}.\\

\noindent
Ctc aims to interact with other softwares, some of them:
\begin{description}
\item[xcluster]
made  by Gavin Scherlock, http://genome-www.stanford.edu/\~\/sherlock/cluster.html
\item[Cluster, Treeview]
made  by Michael Eisen, http://rana.lbl.gov/EisenSoftware.htm
\item[Freeview]
made by Marco Kavcic and Blaz Zupan,
http://magix.fri.uni-lj.si/freeview
\end{description}                 


\noindent
If you want to cite amap or ctc in a publication, use~:

Antoine Lucas and Sylvain Jasson, \emph{Using amap and ctc Packages
  for Huge Clustering}, R News, 2006, vol 6, issue 5 pages 58-60.


\end{document}

\name{hc2Newick}
\alias{hc2Newick}
\title{Convert hclust objects to Newick format files}
\description{
  Convert hclust objects to Newick format files.
}
\usage{
  hc2Newick(hc, flat=TRUE)
}
\arguments{
  \item{hc}{a \code{hclust} object (as returned by the function \code{hclust}
    in the package \code{stats})}
  \item{flat}{a boolean (see section value).}
}
\value{
  If \code{flat=TRUE} the result is a string (that you can write in a
  file).

  If \code{flat=FALSE} the result is a list (of lists). Each list
  is consituted of the elements \code{left}, \code{right} and \code{dist}.  
}

\examples{
data(USArrests)
h = hclust(dist(USArrests))
write(hc2Newick(h),file='hclust.newick')
}


\references{
  Antoine Lucas and Sylvain Jasson, \emph{Using amap and ctc Packages
    for Huge Clustering}, R News, 2006, vol 6, issue 5 pages 58-60.
  }


\author{
  Laurent (laurent@cbs.dtu.dk)
}
\keyword{manip}
\keyword{cluster}

\name{xcluster2r}
\alias{xcluster2r}
\title{Importing Xcluster/Cluster output}
\description{Converting Xcluster/Cluster output (.gtr or .atr) to R hclust file}
\usage{
xcluster2r(file,distance="euclidean",labels=FALSE,fast=FALSE,clean=FALSE,
           dec='.')
}

\arguments{
  \item{file}{the path of a \emph{Xcluster/Cluster} file (.gtr or .atr)}
  \item{distance}{The distance measure used with \emph{Xcluster/Cluster}. This must be one of
    \code{"euclidean"}, \code{"pearson"} or \code{"notcenteredpearson"}.
    Any unambiguous substring can be given.}
  \item{labels}{a logical value indicating whether we use 
    labels values (in the .cdt file) or not.}
  \item{fast}{a logical value indicating whether we reorganize data
    like R (\code{Fast=FALSE}) or we let them like \emph{Xcluster/Cluster} did} 
  \item{clean}{a logical value indicating whether you want the true
    distances (\code{clean=FALSE}), or you want a clean dendrogram (see
  details below).}
  \item{dec}{the character used in the file for decimal points}
}

\details{
See \bold{xcluster} for more details.
}


\value{
  An object of class \bold{hclust} which describes the
  tree produced by the clustering process.
}

\note{
\emph{Xcluster} is a C program made by \emph{Gavin Sherlock} that performs
hierarchical clustering, K-means and SOM. 

\emph{Xcluster} is copyrighted. 
To get or have information
about
\emph{Xcluster}: \url{http://genome-www.stanford.edu/~sherlock/cluster.html}

\emph{Cluster} is a program made by \emph{Michael Eisen} that performs
hierarchical clustering, K-means and SOM. 

\emph{Cluster} is copyrighted. 
To get or have information
about
\emph{Cluster}: \url{http://rana.lbl.gov/EisenSoftware.htm}
}

\references{
  Antoine Lucas and Sylvain Jasson, \emph{Using amap and ctc Packages
    for Huge Clustering}, R News, 2006, vol 6, issue 5 pages 58-60.
  }


\examples{
#    Create data
set.seed(1)
m <- matrix(rep(1,3*24),ncol=3)  
m[9:16,3] <- 3 ; m[17:24,] <- 3    #create 3 groups
m <- m+rnorm(24*3,0,0.5)           #add noise
m <- floor(10*m)/10                #just one digits

r2xcluster(m)


# And once you have Xcluster program:
#
#system('Xcluster -f xcluster.txt -e 0 -p 0 -s 0 -l 0')
#h <- xcluster2r('xcluster.gtr')
#plot(h,hang=-1)
}
\keyword{file}

\author{Antoine Lucas, \url{http://mulcyber.toulouse.inra.fr/projects/amap/}}
\seealso{\code{\link{xcluster}}, \code{\link{r2xcluster}}, \code{\link[stats]{hclust}}, \code{\link[amap]{hcluster}}}

\name{r2cluster}
\alias{r2cluster}
\title{Write to Cluster file format}
\description{Converting data to Cluster format}
\usage{
r2cluster(data,labels=FALSE,colname="ACC",description=FALSE,
          file="cluster.txt",dec='.')
}

\arguments{
  \item{file}{the path of the file}
  \item{data}{a matrix (or data frame) which provides the data to put into the file} 
  \item{labels}{a logical value indicating whether we use the frist
    column as labels (ACC column in cluster file)}
  \item{colname}{a character string
    indicating  what kind of objects are in each row.
    YORF, MCLID, CLID, ACC can be used: see details.
  }
   \item{description}{a logical value indicating whether we use the second column as description (NAME column for cluster file)}
   \item{dec}{the character used in the file for decimal points}  
}

\details{
  Software \emph{Cluster}, made by \emph{M. Eisen} needs formatted
  input data like:

  \preformatted{
ACC     NAME    GWEIGHT GORDER  V3      V4      V5
EWEIGHT                         1       1       1
gbk01   Gene1   1       1       0.9     0.4     1.4
gbk02   Gene2   1       2       0.6     0.2     0.2
gbk03   Gene3   1       3       1.6     1.1     0.9
gbk04   Gene4   1       4       0.4     1       1
  }

  First field of first line (i.e "ACC") is a special field, that tells
  program what kind of objects are in each row.

  
  Four special values are defined with web link (when visualize with
  TreeView):
  \itemize{
    \item  YORF
    \url{http://genome-www.stanford.edu/cgi-bin/dbrun/SacchDB?find+Locus+\%22UNIQID\%22}
    \item MCLID
    \url{http://genome.rtc.riken.go.jp/cgi-bin/getseq?g+R+UNIQID}
    
    \item CLID
    \url{http://genome-www4.stanford.edu/cgi-bin/SMD/source/sourceRes\-ult?op\-tion=CloneID&criteria1=IMAGE:UNIQID&choice=cDNA}
    
    \item ACC
    \url{http://genome-www4.stanford.edu/cgi-bin/SMD/source/sourceRes\-ult?op\-tion=Number&criteria=UNIQID&choice=cDNA}
  }

  Line begining with \code{EWEIGHT} gives weights for each
  column (variable). Column \code{GWEIGHT} gives weights for each line
  (individuals).
  
}


\note{
\emph{Cluster} is a program made by \emph{M. Eisen} that performs
hierarchical clustering, K-means and SOM. 

\emph{Cluster} is copyrighted. 
To get or have information
about
\emph{Cluster}: \url{http://rana.lbl.gov/EisenSoftware.htm}
}

\examples{
#    Create data
set.seed(1)
m <- matrix(rep(1,3*24),ncol=3)  
m[9:16,3] <- 3 ; m[17:24,] <- 3    #create 3 groups
m <- m+rnorm(24*3,0,0.5)           #add noise
m <- floor(10*m)/10                #just one digits

r2cluster(m)

}
\keyword{file}

\references{
  Antoine Lucas and Sylvain Jasson, \emph{Using amap and ctc Packages
    for Huge Clustering}, R News, 2006, vol 6, issue 5 pages 58-60.
  }


\author{Antoine Lucas, \url{http://antoinelucas.free.fr/ctc}}
\seealso{\code{\link{xcluster}}, \code{\link{r2xcluster}}, \code{\link[stats]{hclust}}}

\name{read.eisen}
\alias{read.eisen}
\title{Read expression data from a file formatted for Eisen clustering}
\description{
  The input for Eisen-clustering is a slight variation of a tab 
delimited file. This method reads the expression data from such files as 
a matrix and provides optional additional information on the experiments 
as attributes.
}
\usage{
    read.eisen(file,sep="\t",dec=".", format.check = TRUE)
}
\arguments{
  \item{file}{The relative or absolute path to the file to be read, as 
internally forwarded to the read.table function. }
  \item{sep}{Separator of fields, passed on to read.table. }
  \item{dec}{Passed on to read.table. This is particulary helpful for 
    the interpretation of data from localised spreadsheet programs.}
  \item{format.check}{TRUE or FLASE: to disable file format check.}
}
\details{
The software of Michael Eisen and its plain tab separated format for
the presentation of gene expression data prior to their clustering is
supported by many hard- and software providers, both as an input for
their tools and as resulting from the analysis and normalisation of the
chip images. To be able to read and write this format, the Bioconductor
suite is enabled to easily reanalyse or extend older experiments that
might have been analysed with the Eisen tools before.
}
 
\value{
  A numerical matrix is returned. It is a complete analogue of the 
Eisen-format,
except the descriptions, weights and other information being passed to 
attributes.
The first row will be the column names, the first column will be the 
respective row name.
A second row that has a first empty field is referred to via the 
attribute "second.row".
A column NAME is stored in the attribute "NAME".
}

\author{Steffen Moeller}

\references{Michael Eisen Lab http://rana.lbl.gov/

Michael Hoon's Cluster 3.0  
http://bonsai.ims.u-tokyo.ac.jp/~mdehoon/software/cluster/

Eisen M.B., P.T. Spellman, P.O. Brown, and D. Botstein.   1998.   
Cluster analysis and display of genome-wide expression patterns.   
/Proc. Natl. Acad. Sci. USA /, 95:14863-14868.

De Hoon M.J.L., S. Imoto, J. Nolan, and S. Miyano. Open source 
clustering software.   Bioinformatics *20* (9): 1453--1454 (2004).

Antoine Lucas and Sylvain Jasson, \emph{Using amap and ctc Packages
    for Huge Clustering}, R News, 2006, vol 6, issue 5 pages 58-60.

}

\keyword{cluster}

\name{r2gtr}
\alias{r2gtr}
\alias{r2atr}
\alias{r2cdt}
\title{Write to gtr, atr, cdt file format}
\description{Write data frame and hclust object to gtr atr,
  cdt files (Xcluster or Cluster output).
  Visualisation of cluster can be
  done with tools like treeview}
\usage{
r2gtr(hr,file="cluster.gtr",distance=hr$dist.method,dec='.',digits=5)
r2atr(hc,file="cluster.atr",distance=hc$dist.method,dec='.',digits=5)
r2cdt(hr,hc,data,labels=FALSE,description=FALSE,file="cluster.cdt",dec='.')
}


\details{Function \code{\link{hclust2treeview}} compute hierarchical
  clustering and export to all files at once.}



\arguments{
  \item{file}{the path of the file}
  \item{data}{a matrix (or data frame) which provides the data to put into the file} 
  \item{hr,hc}{objects of class hclust (rows and columns)}
  \item{distance}{The distance measure used. This must be one of
          `"euclidean"', `"maximum"', `"manhattan"', `"canberra"' or
          `"binary"'. Any unambiguous substring can be given.} 
  \item{digits}{number digits for precision} 
  \item{labels}{a logical value indicating whether we use the frist column as labels (NAME column for cluster file)}
  \item{description}{a logical value indicating whether we use the second column as description (DESCRIPTION column for cluster file)}
  \item{dec}{the character used in the file for decimal points}

}

\examples{
#    Create data
set.seed(1)
m <- matrix(rep(1,3*24),ncol=3)  
m[9:16,3] <- 3 ; m[17:24,] <- 3    #create 3 groups
m <- m+rnorm(24*3,0,0.5)           #add noise
m <- floor(10*m)/10                #just one digits

# use library stats
# Cluster columns
hc <- hclust(dist(t(m)))
# Cluster rows
hr <- hclust(dist(m))

# Export files
r2atr(hc,file="cluster.atr")
r2gtr(hr,file="cluster.gtr")
r2cdt(hr,hc,m ,file="cluster.cdt")

}
\keyword{cluster}

\references{
  Antoine Lucas and Sylvain Jasson, \emph{Using amap and ctc Packages
    for Huge Clustering}, R News, 2006, vol 6, issue 5 pages 58-60.
  }


\author{Antoine Lucas, \url{http://antoinelucas.free.fr/ctc}}
\seealso{\code{\link{r2xcluster}}, \code{\link{xcluster2r}},\code{\link[stats]{hclust}},\code{\link[amap]{hcluster}}}

\name{hclust2treeview}
\alias{hclust2treeview}
\title{Hierarchical clustering and treeview export}
\description{
  This function compute hierachical clustering with function
  hcluster and export cluster to treeview files format.
}

\usage{
hclust2treeview(x,file="cluster.cdt",method = "euclidean",link = "complete",keep.hclust=FALSE)
}

\details{This function producte all 3 files needed by treeview, with
  extentions: cdt, gtr, atr.}

\arguments{
 \item{x}{numeric matrix or a data frame or an object of class
    "exprSet".}
  \item{file}{File name of export file.}
  \item{method}{the distance measure to be used. This must be one of
    \code{"euclidean"}, \code{"maximum"}, \code{"manhattan"},
    \code{"canberra"} \code{"binary"} \code{"pearson"},
    \code{"correlation"} or  \code{"spearman"}.
    Any unambiguous substring can be given.}
  \item{link}{the agglomeration method to be used. This should
    be (an unambiguous abbreviation of) one of
    \code{"ward"}, \code{"single"}, \code{"complete"},
    \code{"average"}, \code{"mcquitty"}, \code{"median"} or
    \code{"centroid"}.}
  \item{keep.hclust}{if TRUE: function returns a list of 2 objects of
    class hclust}
}

\value{
  if keep.hclust = FALSE, function return 1.
  else function returns 2 objects of class hclust, first: hierachical
  clustering by rows, second: hierarchical clustering by columns
}



\author{Antoine Lucas, \url{http://mulcyber.toulouse.inra.fr/projects/amap/}}

\seealso{\code{\link[stats]{hclust}}}

\references{
  Antoine Lucas and Sylvain Jasson, \emph{Using amap and ctc Packages
    for Huge Clustering}, R News, 2006, vol 6, issue 5 pages 58-60.
  }


\examples{

data(USArrests)
hclust2treeview(USArrests,file="cluster.cdt")

}


\keyword{cluster}

\name{xcluster}
\alias{xcluster}
\title{Hierarchical clustering}
\description{Performs a hierarchical cluster analysis on a set of
     dissimilarities (this function launch an external program: Xcluster).}
\usage{
xcluster(data,distance="euclidean",clean=FALSE,tmp.in="tmp.txt",tmp.out="tmp.gtr")
}

\arguments{
  \item{data}{a matrix (or data frame) which provides the data to analyze} 
  \item{distance}{The distance measure used with \emph{Xcluster}. This must be one of
    \code{"euclidean"}, \code{"pearson"} or \code{"notcenteredpearson"}.
    Any unambiguous substring can be given.}
    \item{clean}{a logical value indicating whether you want the true
    distances (\code{clean=FALSE}), or you want a clean dendrogram}
    \item{tmp.in, tmp.out}{temporary files for Xcluster}
}

\details{
  Available distance measures are (written for two vectors \eqn{x} and
  \eqn{y}): 
  \itemize{
    \item Euclidean: Usual square distance between the two vectors (2 norm).
    \item Pearson: \eqn{1- \mbox{cor}(x,y)}{1 - cor(x,y)}
    \item Pearson not centered: \eqn{1 - \frac{\sum_i x_i y_i}{\left(\sum_i x_i^2
     \sum_i y_i^2 \right) ^{1/2}}   }{1 - [ sum x_i y_i ] / sqrt[ sum x_i^2 * sum y_i^2 ] }
    }
    
Xcluster does not use usual agglomerative methods (single, average, complete),
but    compute  the distance between each 
    groups' barycenter  for the distance between two groups.

This have a problem for this kind of data:

\tabular{rll}{
A     \tab  0   \tab     0\cr
B     \tab  0   \tab     1\cr
C     \tab   0.9   \tab  0.5\cr
}

Ie: a triangular in \bold{R}\eqn{^2}, the distance between A and B is larger
than the distance between the group A,B and C (with euclidean distance).

For that case it can be useful to use \code{clean=TRUE} and that mean
that you must not consider A and B as a group without C.
}


\value{
  An object of class \bold{hclust} which describes the
  tree produced by the clustering process.
  The object is a list with components:

  \item{merge}{an \eqn{n-1} by 2 matrix.
    Row \eqn{i} of \code{merge} describes the merging of clusters
    at step \eqn{i} of the clustering.
    If an element \eqn{j} in the row is negative,
    then observation \eqn{-j} was merged at this stage.
    If \eqn{j} is positive then the merge
    was with the cluster formed at the (earlier) stage \eqn{j}
    of the algorithm.
    Thus negative entries in \code{merge} indicate agglomerations
    of singletons, and positive entries indicate agglomerations
    of non-singletons.}

  \item{height}{a set of \eqn{n-1} non-decreasing real values.
    The clustering \emph{height}: that is, the value of
    the criterion associated with the clustering
    \code{method} for the particular agglomeration.}

  \item{order}{a vector giving the permutation of the original
    observations suitable for plotting, in the sense that a cluster
    plot using this ordering and matrix \code{merge} will not have
    crossings of the branches.}

  \item{labels}{labels for each of the objects being clustered.}

  \item{call}{the call which produced the result.}

  \item{method}{the cluster method that has been used.}

  \item{dist.method}{the distance that has been used to create \code{d}
    (only returned if the distance object has a \code{"method"}
    attribute).}
}

\note{
\emph{Xcluster} is a C program made by \emph{Gavin Sherlock} that performs
hierarchical clustering, K-means and SOM. 

\emph{Xcluster} is copyrighted. 
To get or have information
about
\emph{Xcluster}: \url{http://genome-www.stanford.edu/~sherlock/cluster.html}
}

\references{
  Antoine Lucas and Sylvain Jasson, \emph{Using amap and ctc Packages
    for Huge Clustering}, R News, 2006, vol 6, issue 5 pages 58-60.
  }


\examples{
#    Create data
set.seed(1)
m <- matrix(rep(1,3*24),ncol=3)  
m[9:16,3] <- 3 ; m[17:24,] <- 3    #create 3 groups
m <- m+rnorm(24*3,0,0.5)           #add noise
m <- floor(10*m)/10                #just one digits


# And once you have Xcluster program:
#
#h <- xcluster(m)
#
#plot(h) 
}
\keyword{cluster}

\author{Antoine Lucas, \url{http://mulcyber.toulouse.inra.fr/projects/amap/}}
\seealso{\code{\link{r2xcluster}}, \code{\link{xcluster2r}},\code{\link[stats]{hclust}}, \code{\link[amap]{hcluster}}}

\name{r2xcluster}
\alias{r2xcluster}
\title{Write to Xcluster file format}
\description{Converting data to Xcluster format}
\usage{
r2xcluster(data,labels=FALSE,description=FALSE,file="xcluster.txt")
}

\arguments{
  \item{file}{the path of the file}
  \item{data}{a matrix (or data frame) which provides the data to put into the file} 
   \item{labels}{a logical value indicating whether we use the frist column as labels (NAME column for xcluster file)}
   \item{description}{a logical value indicating whether we use the second column as description (DESCRIPTION column for cluster file)}
}


\note{
\emph{Xcluster} is a C program made by \emph{Gavin Sherlock} that performs
hierarchical clustering, K-means and SOM. 

\emph{Xcluster} is copyrighted. 
To get or have information
about
\emph{Xcluster}: \url{http://genome-www.stanford.edu/~sherlock/cluster.html}
}

\details{
  Software \emph{Xcluster}, made by \emph{G. Sherlock} needs formatted
  input data like:

  \preformatted{
NAME    DESCRIPTION     GWEIGHT V2      V3      V4
EWEIGHT                         1       1       1
gbk01   Gene1           1       0.9     0.4     1.4
gbk02   Gene2           1       0.6     0.2     0.2
gbk03   Gene3           1       1.6     1.1     0.9
gbk04   Gene4           1       0.4     1       1
  }

  Line begining with \code{EWEIGHT} gives weights for each
  column (variable). Column \code{GWEIGHT} gives weights for each line
  (individuals).
  

}


\references{
  Antoine Lucas and Sylvain Jasson, \emph{Using amap and ctc Packages
    for Huge Clustering}, R News, 2006, vol 6, issue 5 pages 58-60.
}

\examples{
##    Create data
set.seed(1)
m <- matrix(rep(1,3*24),ncol=3)  
m[9:16,3] <- 3 ; m[17:24,] <- 3    #create 3 groups
m <- m+rnorm(24*3,0,0.5)           #add noise
m <- floor(10*m)/10                #just one digits

r2xcluster(m)

## And once you have Xcluster program:

\dontrun{
  system('Xcluster -f xcluster.txt -e 0 -p 0 -s 0 -l 0')
  h <- xcluster2r('xcluster.gtr')
  plot(h,hang=-1)
  }
}
\keyword{file}

\author{Antoine Lucas, \url{http://antoinelucas.free.fr/ctc}}
\seealso{\code{\link{xcluster}}, \code{\link{xcluster2r}}, \code{\link[stats]{hclust}}, \code{\link[amap]{hcluster}}}
